scala.tools.nsc.typechecker

# StdAttachments

###
Related Doc: package typechecker

#### trait StdAttachments extends AnyRef

Self Type
  Analyzer
Source
  StdAttachments.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
Analyzer, Duplicator, Duplicators, Erasure, SpecializationDuplicator, TreeCheckers, erasure, treeChecker
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. StdAttachments
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### type MacroContext = Analyzer.UnaffiliatedMacroContext { val universe: StdAttachments.this.global.type }

2. #### case class MacroExpanderAttachment(original: Global.Tree, desugared: Global.Tree) extends Product with Serializable

   Scratchpad for the macro expander, which is used to store all intermediate data except the details about the runtime.

3. #### case class MacroExpansionAttachment(expandee: Global.Tree, expanded: Any) extends Product with Serializable

   Is added by the macro engine to originals and results of macro expansions.

   Is added by the macro engine to originals and results of macro expansions. Stores the original expandee as it entered the `macroExpand` function.

4. #### case class MacroRuntimeAttachment(delayed: Boolean, typerContext: Analyzer.Context, macroContext: Option[Analyzer.MacroContext]) extends Product with Serializable

5. #### case class SuperArgsAttachment(argss: List[List[Global.Tree]]) extends Product with Serializable

   After being synthesized by the parser, primary constructors aren't fully baked yet.

   After being synthesized by the parser, primary constructors aren't fully baked yet. A call to super in such constructors is just a fill-me-in-later dummy resolved later by `parentTypes`. This attachment coordinates `parentTypes` and `typedTemplate` and allows them to complete the synthesis.

6. #### type UnaffiliatedMacroContext = Context

   Carries information necessary to expand the host tree.

   Carries information necessary to expand the host tree. At times we need to store this info, because macro expansion can be delayed until its targs are inferred. After a macro application has been successfully expanded, this attachment is destroyed.

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from StdAttachments to any2stringadd[StdAttachments] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (StdAttachments, B)

   Implicit information
     This member is added by an implicit conversion from StdAttachments to ArrowAssoc[StdAttachments] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object DynamicRewriteAttachment extends Product with Serializable

   Since mkInvoke, the applyDynamic/selectDynamic/etc desugarer, is disconnected from typedNamedApply, the applyDynamicNamed argument rewriter, the latter doesn’t know whether it needs to apply the rewriting because the application has just been desugared or it needs to hold on because it’s already performed a desugaring on this tree.

   Since mkInvoke, the applyDynamic/selectDynamic/etc desugarer, is disconnected from typedNamedApply, the applyDynamicNamed argument rewriter, the latter doesn’t know whether it needs to apply the rewriting because the application has just been desugared or it needs to hold on because it’s already performed a desugaring on this tree. This has led to SI-8006.

   This attachment solves the problem by providing a means of communication between the two Dynamic desugarers, which solves the aforementioned issue.

7. #### object MacroImplRefAttachment extends Product with Serializable

   See also

     markMacroImplRef

8. #### object SuppressMacroExpansionAttachment extends Product with Serializable

   When present, suppresses macro expansion for the host.

   When present, suppresses macro expansion for the host. This is occasionally necessary, e.g. to prohibit eta-expansion of macros.

   Does not affect expandability of child nodes, there's context.withMacrosDisabled for that (but think thrice before using that API - see the discussion at https://github.com/scala/scala/pull/1639).

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

10. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

11. #### def ensuring(cond: (StdAttachments) ⇒ Boolean, msg: ⇒ Any): StdAttachments

    Implicit information
      This member is added by an implicit conversion from StdAttachments to Ensuring[StdAttachments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (StdAttachments) ⇒ Boolean): StdAttachments

    Implicit information
      This member is added by an implicit conversion from StdAttachments to Ensuring[StdAttachments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): StdAttachments

    Implicit information
      This member is added by an implicit conversion from StdAttachments to Ensuring[StdAttachments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): StdAttachments

    Implicit information
      This member is added by an implicit conversion from StdAttachments to Ensuring[StdAttachments] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from StdAttachments to StringFormat[StdAttachments] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

20. #### def hasMacroExpansionAttachment(any: Any): Boolean

    Determines whether the target is either an original or a result of a macro expansion.

    Determines whether the target is either an original or a result of a macro expansion. The parameter is of type `Any`, because macros can expand both into trees and into annotations.

21. #### def hasSuperArgs(tree: Global.Tree): Boolean

    Determines whether the given tree has an associated SuperArgsAttachment.

22. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

23. #### def isDynamicRewrite(tree: Global.Tree): Boolean

24. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

25. #### def isMacroExpansionSuppressed(tree: Global.Tree): Boolean

    Determines whether a tree should not be expanded, because someone has put SuppressMacroExpansionAttachment on it or one of its children.

26. #### def isMacroImplRef(tree: Global.Tree): Boolean

    Determines whether a tree should or should not be adapted, because someone has put MacroImplRefAttachment on it.

27. #### def linkExpandeeAndDesugared(expandee: Global.Tree, desugared: Global.Tree): Unit

    After macro expansion is completed, links the expandee and the expansion result by annotating them both with a `MacroExpansionAttachment`.

28. #### def linkExpandeeAndExpanded(expandee: Global.Tree, expanded: Any): Unit

    After macro expansion is completed, links the expandee and the expansion result by annotating them both with a `MacroExpansionAttachment`.

    After macro expansion is completed, links the expandee and the expansion result by annotating them both with a `MacroExpansionAttachment`. The `expanded` parameter is of type `Any`, because macros can expand both into trees and into annotations.

29. #### def macroExpandee(tree: Global.Tree): Global.Tree

    Returns the original tree of the macro expansion if the argument is a macro expansion or EmptyTree otherwise.

30. #### def macroExpanderAttachment(tree: Global.Tree): Analyzer.MacroExpanderAttachment

    Loads underlying MacroExpanderAttachment from a macro expandee or returns a default value for that attachment.

31. #### def markDynamicRewrite(tree: Global.Tree): Global.Tree

32. #### def markMacroImplRef(tree: Global.Tree): Global.Tree

    Marks the tree as a macro impl reference, which is a naked reference to a method.

    Marks the tree as a macro impl reference, which is a naked reference to a method.

    This is necessary for typechecking macro impl references (see `DefaultMacroCompiler.defaultResolveMacroImpl`), because otherwise typing a naked reference will result in the "follow this method with `_' if you want to treat it as a partially applied function" errors.`

    This mark suppresses adapt except for when the annottee is a macro application.

33. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

34. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

35. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

36. #### def superArgs(tree: Global.Tree): Option[List[List[Global.Tree]]]

    Convenience method for `SuperArgsAttachment`.

    Convenience method for `SuperArgsAttachment`. Compared with `MacroRuntimeAttachment` this attachment has different a usage pattern, so it really benefits from a dedicated extractor.

37. #### def suppressMacroExpansion(tree: Global.Tree): Global.Tree

    Suppresses macro expansion of the tree by putting SuppressMacroExpansionAttachment on it.

38. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

39. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

40. #### def unmarkDynamicRewrite(tree: Global.Tree): Global.Tree

41. #### def unmarkMacroImplRef(tree: Global.Tree): Global.Tree

    Unmarks the tree as a macro impl reference (see `markMacroImplRef` for more information).

    Unmarks the tree as a macro impl reference (see `markMacroImplRef` for more information).

    This is necessary when a tree that was previously deemed to be a macro impl reference, typechecks to be a macro application. Then we need to unmark it, expand it and try to treat its expansion as a macro impl reference.

42. #### def unsuppressMacroExpansion(tree: Global.Tree): Global.Tree

    Unsuppresses macro expansion of the tree by removing SuppressMacroExpansionAttachment from it and its children.

43. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### def →[B](y: B): (StdAttachments, B)

    Implicit information
      This member is added by an implicit conversion from StdAttachments to ArrowAssoc[StdAttachments] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from StdAttachments to any2stringadd[StdAttachments]

### Inherited by implicit conversion StringFormat from StdAttachments to StringFormat[StdAttachments]

### Inherited by implicit conversion Ensuring from StdAttachments to Ensuring[StdAttachments]

### Inherited by implicit conversion ArrowAssoc from StdAttachments to ArrowAssoc[StdAttachments]

### Ungrouped